package com.zcloud.service.emergency.impl;

import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.mapper.datasource.emergency.EmergencyDrillAttachmentMapper;
import com.zcloud.service.emergency.EmergencyDrillAttachmentService;
import com.zcloud.util.Smb;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 说明：应急演练方案文本
 * 作者：luoxiaobao
 * 时间：2021-06-19
 * 官网：www.zcloudchina.com
 */
@Service
@Transactional //开启事物
public class EmergencyDrillAttachmentServiceImpl implements EmergencyDrillAttachmentService{

	@Autowired
	private EmergencyDrillAttachmentMapper emergencydrillattachmentMapper;
	@Autowired
	private Smb smb;
	/**新增
	 * @param pd
	 * @throws Exception
	 */
	public void save(PageData pd)throws Exception{
		emergencydrillattachmentMapper.save(pd);
	}

	/**删除
	 * @param pd
	 * @throws Exception
	 */
	public void delete(PageData pd)throws Exception{
		emergencydrillattachmentMapper.delete(pd);
	}

	/**修改
	 * @param pd
	 * @throws Exception
	 */
	public void edit(PageData pd)throws Exception{
		emergencydrillattachmentMapper.edit(pd);
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	public List<PageData> list(Page page)throws Exception{
		return emergencydrillattachmentMapper.datalistPage(page);
	}

	/**列表(全部)
	 * @param pd
	 * @throws Exception
	 */
	public List<PageData> listAll(PageData pd)throws Exception{
		return emergencydrillattachmentMapper.listAll(pd);
	}

	/**通过id获取数据
	 * @param pd
	 * @throws Exception
	 */
	public PageData findById(PageData pd)throws Exception{
		return emergencydrillattachmentMapper.findById(pd);
	}

	/**批量删除
	 * @param pd
	 * @throws Exception
	 */
	public void deleteAll(PageData pd)throws Exception{
		emergencydrillattachmentMapper.deleteAll(pd);
	}

	/**通过应急演练基础信息ID获取数据
	 * @param pd
	 * @throws Exception
	 */
	public PageData goEditByBasicId(PageData pd) {
		List<PageData> pageData = emergencydrillattachmentMapper.goEditByBasicId(pd);

		return pageData.size()>0?pageData.get(0):null;
	}

	/**批量删除
	 * @param pd
	 * @throws Exception
	 */
	public void deleteByBaseId(PageData pd)throws Exception{
		List<PageData> pageData = emergencydrillattachmentMapper.goEditByBasicId(pd);
		for (PageData d: pageData) {
			smb.deleteFile(d.getString("DRILL_ATTACHMENT_FILE_PATH"));
		}
		emergencydrillattachmentMapper.deleteByBaseId(pd);
	}
}

